Reduces the map to a single value using a callback function

- « Ds\Map::putAll

- Ds\Map::remove »

- PHP Manual
- Ds\Map
- Reduces the map to a single value using a callback function

# Ds\Map::reduce

(PECL ds >= 1.0.0)

Ds\Map::reduce — Reduces the map to a single value using a callback function

### Description

public Ds\Map::reduce(callable `$callback`, mixed `$initial` = ?): mixed

Reduces the map to a single value using a callback function.

### Parameters

`callback`
  callback(mixed `$carry`, mixed `$key`, mixed `$value`): mixed
  `carry`

    The return value of the previous callback, or `initial` if it's the first iteration.

  `key`

    The key of the current iteration.

  `value`

    The value of the current iteration.

`initial`

  The initial value of the carry value. Can be `null`.

### Return Values

The return value of the final callback.

### Examples

Example #1 Ds\Map::reduce() with initial value example

    <?php$map = new \Ds\Map(["a" => 1, "b" => 2, "c" => 3]);$callback = function($carry, $key, $value) {    return $carry * $value;};var_dump($map->reduce($callback, 5));// Iterations://// $carry = $initial = 5//// $carry = $carry * 1 =  5// $carry = $carry * 2 = 10// $carry = $carry * 3 = 30?>

The above example will output something similar to:

    int(30)

Example #2 Ds\Map::reduce() without an initial value example

    <?php$map = new \Ds\Map(["a" => 1, "b" => 2, "c" => 3]);var_dump($map->reduce(function($carry, $key, $value) {    return $carry + $value + 5;}));// Iterations://// $carry = $initial = null//// $carry = $carry + 1 + 5 =  6// $carry = $carry + 2 + 5 = 13// $carry = $carry + 3 + 5 = 21?>

The above example will output something similar to:

    int(21)